#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ChatWord.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ChatWord> M_ChatWord::msSingleton(nullptr);

int M_ChatWord::GetCount()
{
	return (int)mMapData.size();
}

const M_ChatWordData* M_ChatWord::GetData(int WordId)
{
	auto it = mMapData.find(WordId);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ChatWordData>& M_ChatWord::GetMapData()
{
	return mMapData;
}

void M_ChatWord::Reload()
{
	mMapData.clear();
	Load();
}

void M_ChatWord::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ChatWordData data;
		data.mWordId = element->IntAttribute("WordId");
		data.mText = element->Attribute("Text");
		if (mMapData.find(data.mWordId) != mMapData.end())std::cout <<"data refind:" << data.mWordId << std::endl;
		assert(mMapData.find(data.mWordId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mWordId, data));
		element = element->NextSiblingElement();
	}
}

void M_ChatWord::Load()
{
	Load("../Config/M_ChatWord.xml");
}

M_ChatWord* M_ChatWord::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ChatWord());
	}
	return msSingleton.get();
}
